# -*- coding:Utf-8 -*-

# ####################################################
#  ######  Description du plugin
# ####################################################
# * Gestion des rates/cl-cmdrate/cl_updaterate
# * Affichage d'infos lors de la mort d'un joueur
# * Message de bienvenue
# * Affichage de menu par mot clé dans le chat : bzhregles, bzhconfig ...
# * TTlTchargement de sons d'entrTe du serveur
# ####################################################

import es
from es import server_var
import os
import gamethread
import playerlib
import usermsg

import psyco
psyco.full()

info = es.AddonInfo()
info.name = "PN ForceRates"
info.version = "2.1"
info.author = "p@tneze"
info.url = "http://mattie.info/forums/"
info.description = "Gestion des cvars rate, cl_cmdrate, cl_updaterate"
info.tags = "player,management, rate, cmdrate, updaterate"

# ####################################################
#  ######  Variables globales
# ####################################################

# Valeurs min et max de rate
pn_min_rate = es.ServerVar('pn_min_rate')
pn_max_rate = es.ServerVar('pn_max_rate')

# Valeurs min et max de cl_cmdrate
pn_max_cmdrate = es.ServerVar('pn_max_cmdrate')
pn_min_cmdrate = es.ServerVar('pn_min_cmdrate')

# Valeurs min et max de cl_updaterate
pn_max_updaterate = es.ServerVar('pn_max_updaterate')
pn_min_updaterate = es.ServerVar('pn_min_updaterate')

# Mettre les valeurs INTERP voulues
pn_interp = 0.05
pn_interpolate = 1

# Liste des joueurs entrants
listeJoueursRateVerifies = []

# ####################################################
#  ######  ConVar publiques pour tracer le script sur les moniteurs de serveurs
# ####################################################
#pn_forcerates_version = es.ServerVar("pn_forcerates_version",info.version).makepublic()

# ####################################################
#  ######  Evenements
# ####################################################
def load():
    es.dbgmsg(0,"___(pn_forcerates)___: Plugin pn_forcerates chargé - version " + str(info.version))

	# Récupération de la config voulue pour les CVAR à partir du fichier pn_forcerates.cfg
    if os.path.isfile(es.getAddonPath('pn_forcerates') + '/pn_forcerates.cfg'):
        es.server.cmd('es_xmexec ../addons/eventscripts/pn_forcerates/pn_forcerates.cfg')
    else:
        es.dbgmsg(0, '___(pn_forcerates)___: impossible de charger pn_forcerates.cfg. Vérifier que ce fichier est dans ./pn_forcerates/')

def unload():
    es.dbgmsg(0,"___(pn_forcerates)___: Plugin pn_forcerates déchargé - version " + str(info.version))

def player_activate(ev):
	if not (es.isbot(ev['userid'])) and (es.exists('userid',ev['userid'])):
	    player_rate = es.getclientvar(ev['userid'], 'rate')
	    player_cmdrate = es.getclientvar(ev['userid'], 'cl_cmdrate')
	    player_updaterate = es.getclientvar(ev['userid'], 'cl_updaterate')
	    gamethread.delayed(5, forcer_rates,(player_rate,player_cmdrate,player_updaterate,ev['userid']))

def player_spawn(ev):
	# vérification que le joueur n'a re-changé ses cvar RATE
	global listeJoueursRateVerifies

	if not (es.isbot(ev['userid'])) and (es.exists('userid',ev['userid'])):
		if (ev['userid'] in listeJoueursRateVerifies):
			player_rate = es.getclientvar(ev['userid'], 'rate')
			player_cmdrate = es.getclientvar(ev['userid'], 'cl_cmdrate')
			player_updaterate = es.getclientvar(ev['userid'], 'cl_updaterate')
			avertissement_rates(player_rate,player_cmdrate,player_updaterate,ev['userid'])
		else:
			es.dbgmsg(1,"___(pn_forcerates)___: RATE pas encore vérifiés pour " +str(es.getplayername(ev['userid'])))

def player_disconnect(ev):
	global listeJoueursRateVerifies

	if (ev['userid'] in listeJoueursRateVerifies):
		listeJoueursRateVerifies.remove(ev['userid'])

# ####################################################
#  ######  Fonctions
# ####################################################

def filtrer(valeur_brute):
	# filtrage des caractères parasites
	tmp1 = valeur_brute.split('.',2)
	tmp2 = tmp1[0].split(' ',2)
	tmp3 = tmp2[0].split('-',2)
	tmp4 = tmp3[0].split('+',2)
	tmp5 = tmp4[0].split('*',2)
	tmp6 = tmp5[0].split(',',2)
	tmp = tmp6[0].split('\x93',2)

	try:
		value = int(tmp[0])
	except ValueError:
		value = 0

	return int(value)

def forcer_rates(rate,cmdrate,updaterate,userid):
	# Analyse des cvar et affichage pour modifier chez le client au besoin
	global listeJoueursRateVerifies

	playerName = es.getplayername(userid)

	infos_msg = {	'type': 0 , # 0=Text,2=URL,3=Stringtable,3=File
					'title':'RATE/CL_CMDRATE/CL_UPDATERATE Control', # Titre de la fenêtre MOTD
					'msg':'', # message affiché dans la fenêtre MOTD
					'cmd':''} # commande executée chez le client après validation de la fenêtre MOTD
	showMsg = 0

	es.dbgmsg(1,"___(pn_forcerates)___: Joueur:"+str(playerName)+" rate="+ str(rate)+",cmdrate="+str(cmdrate)+",updaterate="+str(updaterate))

	player_rate = filtrer(str(rate))
	player_cmdrate = filtrer(str(cmdrate))
	player_updaterate = filtrer(str(updaterate))

	# Analyse du RATE
	if (player_rate < pn_min_rate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MIN pour rate pour "+str(playerName)+": "+ str(player_rate)+" -> "+str(pn_min_rate)+" (valeur min du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "RATE changé: "+str(player_rate)+" -> "+str(pn_min_rate)+" (MIN du serveur)\n"
		infos_msg['cmd'] = "rate " + str(pn_min_rate) + ";" + infos_msg['cmd']
		showMsg = 1
	elif (player_rate > pn_max_rate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MAX pour rate pour "+str(playerName)+": "+ str(player_rate)+" -> "+str(pn_max_rate)+" (valeur max du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "RATE changé:"+str(player_rate)+"->"+str(pn_max_rate)+"(MAX du serveur)\n"
		infos_msg['cmd'] = "rate " + str(pn_max_rate) + ";" + infos_msg['cmd']
		showMsg = 1
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif rate pour "+str(playerName)+" ("+str(userid)+")")

	# Analyse du CMDRATE
	if (player_cmdrate < pn_min_cmdrate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MIN pour cl_cmdrate pour "+str(playerName)+": "+ str(player_cmdrate)+" -> "+str(pn_min_cmdrate)+" (valeur min du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "CL_CMDRATE changé:"+str(player_cmdrate)+"->"+str(pn_min_cmdrate)+"(MIN du serveur)\n"
		infos_msg['cmd'] = "cl_cmdrate " + str(pn_min_cmdrate) + ";" + infos_msg['cmd']
		showMsg = 1
	elif (player_cmdrate > pn_max_cmdrate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MAX pour cl_cmdrate pour "+str(playerName)+": "+ str(player_cmdrate)+" -> "+str(pn_max_cmdrate)+" (valeur max du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "CL_CMDRATE changé:"+str(player_cmdrate)+"->"+str(pn_max_cmdrate)+"(MAX du serveur)\n"
		infos_msg['cmd'] = "cl_cmdrate " + str(pn_max_cmdrate) + ";" + infos_msg['cmd']
		showMsg = 1
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif cl_cmdrate pour "+str(playerName)+" ("+str(userid)+")")

	# Analyse du UPDATERATE
	if (player_updaterate < pn_min_updaterate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MIN pour cl_updaterate pour "+str(playerName)+": "+ str(player_updaterate)+" -> "+str(pn_min_updaterate)+" (valeur max du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "CL_UPDATERATE changé:"+str(player_updaterate)+"->"+str(pn_min_updaterate)+"(MIN du serveur)\n"
		infos_msg['cmd'] = "cl_updaterate " + str(pn_min_updaterate) + ";" + str(infos_msg['cmd'])
		showMsg = 1
	elif (player_updaterate > pn_max_updaterate):
		es.dbgmsg(1,"___(pn_forcerates)___: FORCE MAX pour cl_updaterate pour "+str(playerName)+": "+ str(player_updaterate)+" -> "+str(pn_max_updaterate)+" (valeur max du serveur)")
		infos_msg['msg'] = infos_msg['msg'] + "CL_UPDATERATE changé:"+str(player_updaterate)+"->"+str(pn_max_updaterate)+"(MAX du serveur)\n"
		infos_msg['cmd'] = "cl_updaterate " + str(pn_max_updaterate) + ";" + infos_msg['cmd']
		showMsg = 1
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif cl_updaterate pour "+str(playerName)+" ("+str(userid)+")")

	# LES CVAR RATE DU JOUEUR SONT MIANTENAT VERIFIEES
	listeJoueursRateVerifies.append(userid)
	es.dbgmsg(1,"___(pn_forcerates)___: RATE vérifiés pour " +str(playerName))

	if (showMsg == 1):
		# Affichage de la fenêtre MOTD
		es.dbgmsg(1,"___(pn_forcerates)___: infos_msg['msg']="+str(infos_msg['msg']))
		es.dbgmsg(0,"___(pn_forcerates)___: FORCAGE: Joueur="+str(playerName)+" rate="+ str(rate)+",cmdrate="+str(cmdrate)+",updaterate="+str(updaterate))
		es.dbgmsg(1,"___(pn_forcerates)___: FORCAGE: infos_msg['cmd']="+str(infos_msg['cmd'])+" pour "+str(playerName))
		usermsg.showVGUIPanel(userid, 'info', True, infos_msg)

def avertissement_rates(rate,cmdrate,updaterate,userid):
	# vérification que le joueur n'a re-changé ses cvar RATE. Si oui, le joueur est en mis en spectateur
	playerName = es.getplayername(userid)

	player_rate = filtrer(str(rate))
	player_cmdrate = filtrer(str(cmdrate))
	player_updaterate = filtrer(str(updaterate))

	# Analyse du RATE
	if (player_rate < pn_min_rate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MIN pour rate pour "+str(playerName)+": "+ str(player_rate)+" -> "+str(pn_min_rate)+" (valeur min du serveur)")
		es.changeteam(userid,1)
		menu_rate =  "**********************************************\n"
		menu_rate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_rate += "**********************************************\n"
		menu_rate += "TON RATE (= "+str(player_rate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_rate += "Valeur requise entre "+str(pn_min_rate)+" et "+str(pn_max_rate)+"\n\n"
		menu_rate += "**********************************************\n"
		menu_rate += "POUR LE REGLER, tape dans ta console: rate "+str(pn_min_rate)+"\n"
		menu_rate += "          Puis valide\n\n"
		menu_rate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_rate += "************************************************\n"
		menu_rate += "->0. Fermer le menu\n"
		menu_rate += "************************************************"
		es.menu(10,userid,menu_rate)
	elif (player_rate > pn_max_rate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MAX pour rate pour "+str(playerName)+": "+ str(player_rate)+" -> "+str(pn_max_rate)+" (valeur max du serveur)")
		es.changeteam(userid,1)
		menu_rate =  "**********************************************\n"
		menu_rate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_rate += "**********************************************\n"
		menu_rate += "TON RATE (= "+str(player_rate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_rate += "Valeur requise entre "+str(pn_min_rate)+" et "+str(pn_max_rate)+"\n\n"
		menu_rate += "**********************************************\n"
		menu_rate += "POUR LE REGLER, tape dans ta console: rate "+str(pn_max_rate)+"\n"
		menu_rate += "          Puis valide\n\n"
		menu_rate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_rate += "************************************************\n"
		menu_rate += "->0. Fermer le menu\n"
		menu_rate += "************************************************"
		es.menu(10,userid,menu_rate)
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif rate pour "+str(playerName)+" ("+str(userid)+")")

	# Analyse du CMDRATE
	if (player_cmdrate < pn_min_cmdrate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MIN pour cl_cmdrate pour "+str(playerName)+": "+ str(player_cmdrate)+" -> "+str(pn_min_cmdrate)+" (valeur min du serveur)")
		es.changeteam(userid,1)
		menu_cmdrate =  "**********************************************\n"
		menu_cmdrate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_cmdrate += "**********************************************\n"
		menu_cmdrate += "TON CL_CMDRATE (= "+str(player_cmdrate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_cmdrate += "Valeur requise entre "+str(pn_min_cmdrate)+" et "+str(pn_max_cmdrate)+"\n\n"
		menu_cmdrate += "**********************************************\n"
		menu_cmdrate += "POUR LE REGLER, tape dans ta console: cl_cmdrate "+str(pn_min_cmdrate)+"\n"
		menu_cmdrate += "          Puis valide\n\n"
		menu_cmdrate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_cmdrate += "************************************************\n"
		menu_cmdrate += "->0. Fermer le menu\n"
		menu_cmdrate += "************************************************"
		es.menu(10,userid,menu_cmdrate)
	elif (player_cmdrate > pn_max_cmdrate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MAX pour cl_cmdrate pour "+str(playerName)+": "+ str(player_cmdrate)+" -> "+str(pn_max_cmdrate)+" (valeur max du serveur)")
		es.changeteam(userid,1)
		menu_cmdrate =  "**********************************************\n"
		menu_cmdrate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_cmdrate += "**********************************************\n"
		menu_cmdrate += "TON CL_CMDRATE (= "+str(player_cmdrate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_cmdrate += "Valeur requise entre "+str(pn_min_cmdrate)+" et "+str(pn_max_cmdrate)+"\n\n"
		menu_cmdrate += "**********************************************\n"
		menu_cmdrate += "POUR LE REGLER, tape dans ta console: cl_cmdrate "+str(pn_max_cmdrate)+"\n"
		menu_cmdrate += "          Puis valide\n\n"
		menu_cmdrate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_cmdrate += "************************************************\n"
		menu_cmdrate += "->0. Fermer le menu\n"
		menu_cmdrate += "************************************************"
		es.menu(10,userid,menu_cmdrate)
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif cl_cmdrate pour "+str(playerName)+" ("+str(userid)+")")

	# Analyse du UPDATERATE
	if (player_updaterate < pn_min_updaterate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MIN pour cl_updaterate pour "+str(playerName)+": "+ str(player_updaterate)+" -> "+str(pn_min_updaterate)+" (valeur max du serveur)")
		es.changeteam(userid,1)
		menu_updaterate =  "**********************************************\n"
		menu_updaterate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_updaterate += "**********************************************\n"
		menu_updaterate += "TON CL_UPDATERATE (= "+str(player_updaterate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_updaterate += "Valeur obligatoire entre "+str(pn_min_updaterate)+" et "+str(pn_max_updaterate)+"\n\n"
		menu_updaterate += "**********************************************\n"
		menu_updaterate += "POUR LE REGLER, tape dans ta console: cl_updaterate "+str(pn_min_updaterate)+"\n"
		menu_updaterate += "          Puis valide\n\n"
		menu_updaterate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_updaterate += "************************************************\n"
		menu_updaterate += "->0. Fermer le menu\n"
		menu_updaterate += "************************************************"
		es.menu(10,userid,menu_updaterate)
	elif (player_updaterate > pn_max_updaterate):
		es.dbgmsg(0,"___(pn_forcerates)___: ALERTE MAX pour cl_updaterate pour "+str(playerName)+": "+ str(player_updaterate)+" -> "+str(pn_max_updaterate)+" (valeur max du serveur)")
		es.changeteam(userid,1)
		menu_updaterate =  "**********************************************\n"
		menu_updaterate += "******   AVERTISSEMENT ADMIN BZH       *******\n"
		menu_updaterate += "**********************************************\n"
		menu_updaterate += "TON CL_UPDATERATE (= "+str(player_updaterate)+" ) EST MAL REGLE POUR LE SERVEUR\n"
		menu_updaterate += "Valeur obligatoire entre "+str(pn_min_updaterate)+" et "+str(pn_max_updaterate)+"\n\n"
		menu_updaterate += "**********************************************\n"
		menu_updaterate += "POUR LE REGLER, tape dans ta console: cl_updaterate "+str(pn_max_updaterate)+"\n"
		menu_updaterate += "          Puis valide\n\n"
		menu_updaterate += "SI TU NE LE REGLES PAS,TU RESTERAS EN MODE SPECTATEUR\n"
		menu_updaterate += "************************************************\n"
		menu_updaterate += "->0. Fermer le menu\n"
		menu_updaterate += "************************************************"
		es.menu(10,userid,menu_updaterate)
	else:
		es.dbgmsg(1,"___(pn_forcerates)___: pas de modif cl_updaterate pour "+str(playerName)+" ("+str(userid)+")")
